
#ifndef BST_H_
#define BST_H_

#include "rain.h"

typedef station_info bst_element;

typedef struct node_tag {
	struct node_tag* parent;
	struct node_tag* left;
	struct node_tag* right;
	bst_element key;
} bst_node;

typedef struct bst_tag {
	bst_node* root;
} bst;

void bst_init(bst* t);

/* search operations */
bst_element bst_minimum(bst* t);
bst_element bst_maximum(bst* t);
bst_element bst_search(bst* t, bst_element e);
bst_element bst_predecessor(bst* t, bst_element e);
bst_element bst_successor(bst* t, bst_element e);

bst_node* successor_node(bst_node* n);
bst_node* predecessor_node(bst_node* n);
bst_node* search_node(bst* t, bst_element e);

/* insert operations */
bst_node* bst_insert(bst* t, bst_element e);

/* delete operation */
void bst_delete(bst* t, bst_element e);

#endif /* BST_H_ */




