/*
 * hashtable.h
 *
 *  Created on: Oct 24, 2013
 *      Author: mtk
 */

#ifndef HASHTABLE_H_
#define HASHTABLE_H_
#include "bst.h"

typedef char * key_type;
typedef bst_node* value_type;

typedef struct ht_entry_tag {
	key_type key;
	value_type value;
} entry;

/* keys are unique => if you insert the same key
 * the last value overwrites the previous one.
 */
void ht_insert(key_type k, value_type v);
value_type ht_search(key_type k);
void ht_delete(key_type k);
int ht_contains_key(key_type key);
int ht_size(); // number of elements
key_type* ht_keys(); // array containing all the keys in the table
entry* ht_entries();



void ht_init();
void print_ht_table();


#endif /* HASHTABLE_H_ */
