#include <stdio.h>
#include <stdlib.h>
#include "hashtable.h"
#include "bst.h"
#include "rain.h"

static bst rainFall;

void initStation(){
	ht_init();
	bst_init(&rainFall);
}

void addStation(char* station, double rain){
	station_info p;
	p.rain=rain;
	p.station=station;
	bst_node* n = bst_insert(&rainFall,p);
	ht_insert(station,n);
}

void nearStations(char* station, double range){
	bst_node* start=ht_search(station);

	printf("%s: amount of rain %g\n",station,start->key.rain);
	printf("Similar stations (range: %g)\n",range);

	bst_node* near;
	bst_node* current=start;
	while( (near=predecessor_node(current)) != NULL ){
		if(start->key.rain - near->key.rain <= range){
			printf("    %s: amount of rain %g\n",near->key.station,near->key.rain);
			current=near;
		}else{
			break;
		}
	}
	current=start;
	while( (near=successor_node(current)) != NULL ){
		if(near->key.rain - start->key.rain <= range){
			printf("    %s: amount of rain %g\n",near->key.station,near->key.rain);
			current=near;
		}else{
			break;
		}
	}
}


